<?php
/*======================================================================*\
|| #################################################################### ||
|| #             vBulletin 3.x.x General Forum Info 2.1.1             # ||
|| # ---------------------------------------------------------------- # ||
|| #	   Developed by VietVbb_Team VietNam						  # ||
|| # 	   Website: www.vietvbb.vn									  # ||
|| # ---------------------------------------------------------------- # ||
|| #################################################################### ||
\*======================================================================*/

########################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('NO_REGISTER_GLOBALS', 1);
define('GET_EDIT_TEMPLATES', true);
define('THIS_SCRIPT', 'foruminfo');

// ################### PRE-CACHE TEMPLATES AND DATA ######################

$phrasegroups = array('threadmanage', 'posting');

// get special data templates from the datastore
$specialtemplates = array(
	'smiliecache',
	'bbcodecache',
);

// pre-cache templates used by all actions
$globaltemplates = array(
	'forum_info_edit',
	'forum_info',
	'editor_css',
	'editor_clientscript',
	'editor_jsoptions_font',
	'editor_jsoptions_size'
);

// pre-cache templates used by specific actions
$actiontemplates = array();

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/functions_newpost.php');
require_once(DIR . '/includes/functions_editor.php');
require_once(DIR . '/includes/functions_bigthree.php');
// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################

$forumid = intval($_REQUEST['forumid']);

// needs this to show error if forum does not exist

if (!can_moderate($forumid) OR $forumid == 0)
{
	print_no_permission();
}

$foruminfo = verify_id('forum', $forumid, 1, 1);

// check if there is a forum password and if so, ensure the user has it set
verify_forum_password($foruminfo['forumid'], $foruminfo['password']);

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'showforuminfo';
}

if (!$foruminfo['allowposting'] OR $foruminfo['link'] OR !$foruminfo['cancontainthreads'])
{
	eval(standard_error(fetch_error('forumclosed')));
}

$forumperms = fetch_permissions($forumid);
if (!($forumperms & $vbulletin->bf_ugp_forumpermissions['canview']) OR !($forumperms & $vbulletin->bf_ugp_forumpermissions['canviewthreads']) OR !($forumperms & $vbulletin->bf_ugp_forumpermissions['canpostnew']))
{
	print_no_permission();
}

// check if there is a forum password and if so, ensure the user has it set
verify_forum_password($foruminfo['forumid'], $foruminfo['password']);

 ############################### start update forum info ###############################
if ($_REQUEST['do'] == 'postinfo'  || $_POST['do']  == 'postinfo')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'wysiwyg'			=> TYPE_BOOL,
		'message'			=> TYPE_STR,
		'preview'			=> TYPE_STR,
		'disablesmilies'		=> TYPE_BOOL,
		'parseurl'			=> TYPE_BOOL,
		'username'			=> TYPE_STR,
		'ajax'				=> TYPE_BOOL
	));	

	if ($vbulletin->GPC['wysiwyg'])
	{
		require_once(DIR . '/includes/functions_wysiwyg.php');
		$foruminfo['message'] = convert_wysiwyg_html_to_bbcode($vbulletin->GPC['message'], 0);
	}
	else
	{
		$foruminfo['message'] = $vbulletin->GPC['message'];
	}
	
	if ($vbulletin->GPC['ajax'])
	{
		$foruminfo['message'] = convert_urlencoded_unicode($foruminfo['message']);
	}


	$foruminfo['parseurl'] = true;
	$foruminfo['disablesmilies'] = $vbulletin->GPC['disablesmilies'];
	$foruminfo['preview'] =& $vbulletin->GPC['preview'];


	if ($foruminfo['parseurl'])
	{
		$foruminfo['message'] = convert_url_to_bbcode($foruminfo['message']);
	}

	if($foruminfo['preview'])
	{
		$postpreview = process_post_preview($foruminfo);
		$_REQUEST['do'] = 'showforuminfo';
		$foruminfo['message'] = htmlspecialchars_uni($foruminfo['message']);
	}
	else
	{
	$db->query_write("
		UPDATE " . TABLE_PREFIX . "forum
		SET message = '" . $vbulletin->db->escape_string($foruminfo['message']) . "'
		WHERE forumid = $forumid
	");

	// update forumcache so the changes in categories will take effect
	require_once('./includes/adminfunctions.php');
	build_forum_permissions();

	if ($vbulletin->GPC['ajax'])
	{
	require_once(DIR . '/includes/functions_editor.php');

	$vBeditJs = construct_editor_js_arrays();

	// check that $editor_css has been built
	if (!isset($GLOBALS['editor_css']))
	{
		eval('$GLOBALS[\'editor_css\'] = "' . fetch_template('editor_css') . '";');
		$GLOBALS['headinclude'] .= "<!-- Editor CSS automatically added by " . substr(strrchr(__FILE__, DIRECTORY_SEPARATOR), 1) . " at line " . __LINE__ . " -->\n" . $GLOBALS['editor_css'];
	}

	eval('$vBeditTemplate[\'clientscript\'] = "' . fetch_template('editor_clientscript') . '";');
		require_once(DIR . '/includes/class_bbcode.php');
		$bbcode_parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());
		$foruminfo['message'] = $bbcode_parser->parse($foruminfo['message']);
		eval('$forum_info = "' . fetch_template('forum_info') . '";');
		if (strtolower($vbulletin->userinfo['lang_charset']) == 'iso-8859-1')
		{
			$vbulletin->userinfo['lang_charset'] = 'windows-1252';
		}
		@header('Content-Type: text/html' . iif($vbulletin->userinfo['lang_charset'] != '', '; charset=' . $vbulletin->userinfo['lang_charset']));
		echo "<!-- postbit ok --><!-- time " . TIMENOW . " -->$forum_info";
	}else{
		$vbulletin->url = 'forumdisplay.php?' . $vbulletin->session->vars['sessionurl'] . "f=$forumid";
		eval(print_standard_redirect('redirect_editinfo', true, true));
	}
}
}


// ############################### start show current forum info ###############################
if ($_REQUEST['do'] == 'showforuminfo' || $_POST['do'] == 'showforuminfo')
{
	

	$vbulletin->input->clean_array_gpc('p', array(
		'wysiwyg'			=> TYPE_BOOL,
		'message'			=> TYPE_STR,
		'ajax'				=> TYPE_BOOL
	));

	if ($vbulletin->GPC['ajax'])
	{
		$tmpmessage = ($vbulletin->GPC['ajax'] ? convert_urlencoded_unicode($edit['message']) : $edit['message']);

		$edit = $postinfo;
		$edit['message'] =& $tmpmessage;
		$edit['enablesmilies'] =& $edit['allowsmilie'];
		$edit['disablesmilies'] = $edit['enablesmilies'] ? 0 : 1;
		$edit['parseurl'] = true;

		if ($vbulletin->GPC['wysiwyg'])
		{
			require_once(DIR . '/includes/functions_wysiwyg.php');
			require_once(DIR . '/includes/functions_wysiwyg.php');
			$vbulletin->GPC['message'] = convert_wysiwyg_html_to_bbcode($vbulletin->GPC['message'], $foruminfo['allowhtml']);
			$vars['message']=convert_urlencoded_unicode($vbulletin->GPC['message']);
		}
		else
		{
			$vars['message'] =& $vbulletin->GPC['message'];
		}
		


	}
	else
	{
	$vars = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "forum WHERE forumid = $forumid");
	if($foruminfo['message'])
	{
		$vars['message'] = $foruminfo['message'];
	}
	}
	$editorid = construct_edit_toolbar(
		$vars['message'],
		0,
		$foruminfo['forumid'],
		$foruminfo['allowsmilies'],
		1,
		($forumperms & $vbulletin->bf_ugp_forumpermissions['canpostattachment'] AND $vbulletin->userinfo['userid'])
	);

	if (!isset($checked['parseurl']))
	{
		$checked['parseurl'] = 'checked="checked"';
	}


	// get username code
	eval('$usernamecode = "' . fetch_template('newpost_usernamecode') . '";');

	// draw nav bar

	$navbits = array();
	$parentlist = array_reverse(explode(',', substr($foruminfo['parentlist'], 0, -3)));
	foreach ($parentlist AS $forumID)
	{
		$forumTitle = $vbulletin->forumcache["$forumID"]['title'];
		$navbits['forumdisplay.php?' . $vbulletin->session->vars['sessionurl'] . "f=$forumID"] = $forumTitle;
	}
	$navbits[''] = '  ';
	$navbits = construct_navbits($navbits);
	eval('$navbar = "' . fetch_template('navbar') . '";');
	eval('print_output("' . fetch_template('forum_info_edit') . '");');
}
/*======================================================================*\
|| ####################################################################
|| # VietVBB Team Vietnam
|| ####################################################################
\*======================================================================*/
?>